/*
description:
i was gonna do cube mapping but ...
all normals are popped in in eye space
so i figured i'd just rotate them correctly
but then i realized the modelview rotation goes on in the framework
and i'd have to write bridge routines
so i thought lets write a glget for matrices ...
but setting arbitrary matrices is a faux pas
and getting the interface trans/rot params seems iffy
so why not just write a shader?!
*/

//#define LOOKUP_IN_FRAGMENT

varying vec3 normal;
varying vec4 eye;
varying vec3 cubetc;
varying vec4 color;
varying float refl;

#ifdef VERTEX_SHADER

attribute float reflectivity;

void main() {
	color = gl_Color;
	refl = reflectivity;
	normal = gl_NormalMatrix * gl_Normal;
	eye = gl_ModelViewMatrix * gl_Vertex;
#ifndef LOOKUP_IN_FRAGMENT
	cubetc = reflect( eye.xyz, normalize(normal) ).xyz;
	// now gotta transform the cube tc by the inverse rotation component?
	cubetc = (gl_ModelViewMatrixInverse * vec4(cubetc,0)).xyz;
#endif
	//and we're hip!
	gl_Position = ftransform();
}
#endif

#ifdef FRAGMENT_SHADER

uniform samplerCube cubemap;

void main() {
//	vec4 color = vec4(dot(normalize(eye.xyz), normalize(normal)));
#ifdef LOOKUP_IN_FRAGMENT
	vec3 cubetc = reflect( eye.xyz, normalize(normal) ).xyz;
	// now gotta transform the cube tc by the inverse rotation component?
	cubetc = (gl_ModelViewMatrixInverse * vec4(cubetc,0)).xyz;
#endif

	//lookup in cubemap
	gl_FragColor = textureCube(cubemap, cubetc);
	//now texture alpha doesnt exist, so set it to zero before adding to color
	//that way color alpha is our only alpha
	gl_FragColor.a = 0.;
	//now scale by reflectivity
	gl_FragColor.rgb *= refl;
	//add by color
	gl_FragColor += color;
}
#endif